% Trabajo de Metodos Numericos
% 
%Realizar un programa en MATLAB que resuelve mediante diferencias finitas
%una ecuacion en derivadas parciales eliptica no lineal con condiciones de contorno
%de tipo Dirichlet en un rectangulo. El trabajo debe considerar los siguientes
%aspectos y requisitos:
%       a. Considerar la no linealidad en la conductividad y en el termino fuente.
%       b. Se puede reescribir el programa utilizado en las practicas de clase,
%           modificando el caracter lineal por el no lineal, y resolviendo las ecuaciones no
%           lineales con un metodo adecuado.
%       c. Representar graficamente la solucion.
%
% 
% Codigo

 syms('OK', 'A', 'B', 'C', 'D', 'N', 'M', 'TOL', 'NN', 'MM');
 syms('M1', 'M2', 'N1', 'N2', 'H', 'K', 'I', 'X', 'J');
 syms('Y', 'W', 'V', 'VV', 'L', 'Z', 'E', 'LL', 'FLAG','P','Enl','Wn');
 syms('NAME', 'OUP', 's', 'x', 'y','u');
 TRUE = 1;
 FALSE = 0;
 fprintf(1,'Este es el trabajo de la asignatura de Metodos Numericos.\n');
 fprintf(1,'El programa resuelve mediante diferencias finitas una ecuacion en derivadas\n');
 fprintf(1,'parciales eliptica no lineal con condicines de contorno de tipo Dirichlet\n');
 fprintf(1,'en un rectangulo\n');
 fprintf(1,'Escriba las funciones F(x,y,u) (termino fuente) \n');
 fprintf(1,'Escriba la funcion K(x,y,u) (conductividad) \n');
 fprintf(1,'y G(x,y) (condicion de contorno Dirichlet) en terminos de x e y. \n');
 fprintf(1,'en lineas separadas. \n');
 fprintf(1,'por ejemplo:  u*x*exp(y) \n');
 fprintf(1,'              u*x*y \n');
 fprintf(1,'              x*exp(y) \n');
 s = input(' ','s');
 F = inline(s,'x','y','u');
 s = input(' ','s');
 Ku = inline(s,'x','y','u');
 s = input(' ','s');
 G = inline(s,'x','y');
 OK =FALSE;
 while OK == FALSE
    fprintf(1,'Escriba los puntos extremos del intervalo (A,B) sobre el eje X.\n');
    fprintf(1,'en lineas separadas.\n');
    A = input(' ');
    B = input(' ');
    fprintf(1,'Escriba los puntos extremos del intervalo (C,D) sobre el eje Y.\n');
    fprintf(1,'en lineas separadas.\n');
    C = input(' ');
    D = input(' ');
    if A >= B | C >= D
        fprintf(1,'El extremo inferior debe ser menor que el superior.\n');
    else
        OK = TRUE;
    end;
 end;
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba el numero de intervalos n sobre el eje X \n');
    fprintf(1,'y m sobre el eje Y en lineas separadas. \n');
    fprintf(1,'Ambos valores deben ser mayores que 2.\n');
    N = input(' ');
    M = input(' ');
    if M <= 2 | N <= 2
        fprintf(1,'Los numeros deben ser mayores que 2.\n');
    else
        OK = TRUE;
    end;
 end;
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba la tolerancia.\n');
    TOL = input(' ');
    if TOL <= 0
        fprintf(1,'La tolerancia debe ser positiva.\n');
    else
        OK = TRUE;
    end;
 end;
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Escriba el numero maximo de iteraciones del metodo del Punto Fijo y del metodo de Gauss-Seidel en lineas separadas.\n');
    MM = input(' ');
    NN = input(' ');
    if NN <= 0  or MM <= 0
        fprintf(1,'El numero debe ser un entero positivo.\n');
    else
        OK = TRUE;
    end;
 end;
 fprintf(1,'Elija la forma de salida de datos:\n');
 fprintf(1,'1. Pantalla\n');
 fprintf(1,'2. Fichero de texto\n');
 fprintf(1,'Escriba 1 o 2.\n');
 FLAG = input(' ');
 if FLAG == 2
    fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
    fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
    NAME = input(' ','s');
    OUP = fopen(NAME,'wt');
 else
    OUP = 1;
 end;
 if OK == TRUE
    M1 = M-1;
    M2 = M-2;
    N1 = N-1;
    N2 = N-2;
     % PASO 1
    H = (B-A)/N;
    K = (D-C)/M;
% PASOS 2 y 3: Construccion de los puntos de la malla
% PASO 2
    X = zeros(1,N+1);
    Y = zeros(1,M+1);
    W = ones(N+1,M+1);
    Wn = ones(N+1,M+1);
    matK = ones(N+1,M+1);  %creamos una matriz donde se reflejen los valores de ku para cada x,y,u
    matF = ones (N+1,M+1); % creamos una matriz donde se reflejen los valores de F para cada x,y,u
    for I = 0 : N
        X(I+1) = A+I*H;
    end;
% PASO 3
    for J = 0 : M
        Y(J+1) = C+J*K;
    end;
% PASO 4
    for I = 1 : N1
        W(I+1,1) = G(X(I+1),Y(1));        %define los valores desde el pto (2,1) al (n-1,1)
        W(I+1,M+1) = G(X(I+1),Y(M+1));    %define los valores desde el pto (2,m+1) al (n-1,m+1)
    end;
    for J = 0 : M
        W(1,J+1) = G(X(1),Y(J+1));        %define los valores desde el pto (1,1) al (1,m+1)
        W(N+1,J+1) = G(X(N+1),Y(J+1));    %define los valores desde el pto (n+1,1) al (n+1,m+1)
    end;                                  %se ha definido todo el contorno
    for I = 1 : N1
        for J = 1 : M1
            W(I+1,J+1) = 1;                   %se da un valor inicial cero a todos los ptos interiores
        end;
    end;
    
 % PASO 5
% Usa V para lambda, VV para mu
    V = H*H/(K*K);
    VV = 2*(1+V);
    P=1;
    Enl= 1;
    OK = FALSE;
% Z es un nuevo valor de W(I,J) para usarlo en el calculo de la norma
% del error E utilizado en lugar de NORM
% PASO 6

    while (P<=MM) & (Enl>=TOL)
        for I = 2 : N
            for J = 2 : M
                matK(I,J)= Ku(X(I),Y(J),W(I,J));
                matF(I,J)= F(X(I),Y(J),W(I,J));
            end;
        end;   
        L=1;
        OK=FALSE;
        while L <= NN & OK == FALSE
% PASOS 7: Hasta el PASO 20 realiza iteraciones de Gauss-Seidel
% PASO 7
            Z = (-H*H*matF(2,M1+1)+matK(2,M1+1)*G(A,Y(M1+1))+matK(2,M1+1)*V*G(X(2),D)+matK(2,M1+1)*V*W(2,M2+1)+matK(2,M1+1)*W(3,M1+1))/(matK(2,M1+1)*VV);
            E = abs( W(2,M1+1)-Z);
            W(2,M1+1) = Z;
            
        
    % Aqui habian dos END
 % PASO 8
            for I = 2 : N2
                Z = (-H*H*matF(I+1,M1+1)+matK(I+1,M1+1)*V*G(X(I+1),D)+matK(I+1,M1+1)*W(I,M1+1)+matK(I+1,M1+1)*W(I+2,M1+1)+matK(I+1,M1+1)*V*W(I+1,M2+1))/(matK(I+1,M1+1)*VV);
                if abs(W(I+1,M1+1)-Z) >= E
                    E = abs( W(I+1,M1+1) - Z );
                end;
                W(I+1,M1+1) = Z;
            end;
% PASO 9
            Z = (-H*H*matF(N1+1,M1+1)+matK(N1+1,M1+1)*G(B,Y(M1+1))+matK(N1+1,M1+1)*V*G(X(N1+1),D)+matK(N1+1,M1+1)*W(N2+1,M1+1)+matK(N1+1,M1+1)*V*W(N1+1,M2+1))/(matK(N1+1,M1+1)*VV);
            if abs( W(N1+1,M1+1)-Z) > E
                E = abs( W(N1+1,M1+1)-Z);
            end;
            W(N1+1,M1+1) = Z;
 
% PASO 10
            for LL = 2 : M2
                J = M2-LL+2;
% PASO 11
                Z = (-H*H*matF(2,J+1)+matK(2,J+1)*G(A,Y(J+1))+matK(2,J+1)*V*W(2,J+2)+matK(2,J+1)*V*W(2,J)+matK(2,J+1)*W(3,J+1))/(matK(2,J+1)*VV);
                if abs(W(2,J+1)-Z) > E
                    E = abs(W(2,J+1)-Z);
                end;
                W(2,J+1) = Z;
           
% PASO 12
                for I = 2 : N2
                    Z = (-H*H*matF(I+1,J+1)+matK(I+1,J+1)*W(I,J+1)+matK(I+1,J+1)*V*W(I+1,J+2)+matK(I+1,J+1)*V*W(I+1,J)+matK(I+1,J+1)*W(I+2,J+1))/(matK(I+1,J+1)*VV);
                    if abs(W(I+1,J+1)-Z) > E
                        E = abs(W(I+1,J+1)-Z);
                    end;
                    W(I+1,J+1) = Z;
 
                end;
% PASO 13
                    Z = (-H*H*matF(N1+1,J+1)+matK(N1+1,J+1)*G(B,Y(J+1))+matK(N1+1,J+1)*W(N2+1,J+1)+matK(N1+1,J+1)*V*W(N1+1,J+2)+matK(N1+1,J+1)*V*W(N1+1,J))/(matK(N1+1,J+1)*VV);
                    if abs(W(N1+1,J+1)-Z) > E
                        E = abs(W(N1+1,J+1)-Z);
                    end;
                    W(N1+1,J+1) = Z;
 
            end;
% PASO 14
            Z = (-H*H*matF(2,2)+matK(2,2)*V*G(X(2),C)+matK(2,2)*G(A,Y(2))+matK(2,2)*V*W(2,3)+matK(2,2)*W(3,2))/(matK(2,2)*VV);
            if abs(W(2,2)-Z) > E
                E = abs(W(2,2)-Z);
            end;
            W(2,2) = Z;
 
% PASO 15
            for I = 2 : N2
                Z = (-H*H*matF(I+1,2)+matK(I+1,2)*V*G(X(I+1),C)+matK(I+1,2)*W(I+2,2)+matK(I+1,2)*W(I,2)+matK(I+1,2)*V*W(I+1,3))/(matK(I+1,2)*VV);
                if abs(W(I+1,2)-Z) > E
                    E = abs(W(I+1,2)-Z);
                end;
                W(I+1,2) = Z;
 
            end;
% PASO 16
            Z = (-H*H*matF(N1+1,2)+matK(N1+1,2)*V*G(X(N1+1),C)+matK(N1+1,2)*G(B,Y(2))+matK(N1+1,2)*W(N2+1,2)+matK(N1+1,2)*V*W(N1+1,3))/(matK(N1+1,2)*VV);
                if abs(W(N1+1,2)-Z) > E
                    E = abs(W(N1+1,2)-Z);
                end;
            W(N1+1,2) = Z;
%            fprintf(OUP, 'Gauss-Seidel en la iteracion: %d %13.8f\n',L,E); 
 
% PASO 17
            if E <= TOL
% PASO 18
%                fprintf(OUP, 'Metodo de Diferencias Finitas para una ecuacion eliptica\n\n');
 %               fprintf(OUP,                                             '  I  J    X(I)        Y(J)         W(I,J)\n\n');
  %              for I = 0 : N 
   %                 for J = 0 : M 
    %                    fprintf(OUP, '%3d %2d %11.8f %11.8f %13.8f\n',I,J,X(I+1),Y(J+1),W(I+1,J+1));
    %end;
    %end;
      %         fprintf(OUP, 'Se obtuvo convergencia con Gauss-Seidel en la iteracion: %d %13.8f\n',L,E); 
% PASO 19
                OK = TRUE;
            else
% PASO 20
                L = L+1;
            end;
        end;
        Enl=0;
        for I = 2 : N
            for J = 2 : M
                if abs(Wn(I,J)- W(I,J)) > Enl
                    Enl = abs(Wn(I,J)- W(I,J));
                end;  
        %se podria igualar elemento a elemento
            end;
        end;
        Wn=W;
        P = P+1;
        fprintf(OUP, 'Punto Fijo: iteracion y error: %d %13.8f\n',P,Enl); 
    end;


% PASO 21
    if P > MM 
        fprintf(1,'El metodo del Punto Fijo falla despues de %d iteraciones %13.8f\n', MM,Enl)
    end;
    if L > NN    
        fprintf(1,'El metodo de Gauss-Seidel falla despues de %d iteraciones %13.8f\n', NN,E)
    end;
    if OUP ~= 1 
        fclose(OUP);
        fprintf(1,'Fichero de salida creado satisfactoriamente \n',NAME);
    end;
        figure(1);
        surf(Y,X,W);
        title('PROBLEMA ELIPTICO');
 end;
